package ex8;

import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Created by IntelliJ IDEA.
 * User: AkiraSasaki
 * Date: 2008/06/01
 * Time: 17:36:17
 * To change this template use File | Settings | File Templates.
 */
public class B1Tokenizer {
    StringBuilder stringBuffer;
    CharReader reader;

    public B1Tokenizer(CharReader reader) {
        this.reader = reader;
        stringBuffer = new StringBuilder();
    }
    public TokenClass nextToken() {
        char ch;
        stringBuffer.setLength(0);
        int nextState = 1;
        do {    // 󔒁Asǂݔ΂B
            ch = reader.nextChar();
        } while (charClass(ch)==CharClass.WS);
        loop:
        while (true) {
            switch (nextState) {
                case 1: {
                    if (ch == CharReader.CHAR_EOF)
                        return TokenClass.EOF;
                    if (charClass(ch) == CharClass.LETTER){
                        stringBuffer.append(ch);
                        nextState = 2;
                    }
                    else if (ch == ';'){
                        stringBuffer.append(ch);
                        return TokenClass.SEMI;
                    }
                    else
                        throw new RuntimeException("illegal character: " + ch);
                    break;
                }
                case 2: {
                    ch = reader.nextChar();
                    if (charClass(ch) == CharClass.LETTER ||
                            charClass(ch) == CharClass.DIGIT){
                        stringBuffer.append(ch);
                        nextState = 2;
                    }else {
                        nextState = 5;
                    }
                    break;
                }
                case 5:
                    reader.backChar();
                    String s = currentString();
                    if (s.equals("begin"))
                        return TokenClass.BEGIN;
                    else if (s.equals("end"))
                        return TokenClass.END;
                    return TokenClass.IDENT;
                default: {
                    throw new RuntimeException("should not reach");
                }
            }
        }
    }

    public String currentString(){
        return stringBuffer.toString();
    }
        private CharClass charClass(char c){
        if ( c == ' ' || c == '\n')
            return CharClass.WS;
        if (c >='a' && c <= 'z' || c>='A' && c<= 'Z')
            return CharClass.LETTER;
        if (c >='0' && c <= '9')
            return CharClass.DIGIT;
        else
            return CharClass.OTHERS;
        }
    public static void main(String[] args) {
        // ͊̃eXg
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        B1Tokenizer tokenizer = new B1Tokenizer(new CharReader(br));
        TokenClass tc;
        while((tc= tokenizer.nextToken())!= TokenClass.EOF){
            //EOF(Ō̃g[Nj܂ŁAPg[NoďB
            System.out.print("tc = " + tc + " : ");
            System.out.println("tokenizer.currentString() = " + tokenizer.currentString());
        }
    }
}
